import numpy as np

	class NeuralNetwork(object):
		"""docstring for linear_regression"""
		def __init__(self, X, y):
			super(LinearRegression, self).__init__()
			self.X_train = np.array(X)
			self.y_train = np.array(y)

		def fit(self, num_iters, alpha):
			self.coeff__ = np.zeros(self.X_train.shape[1]) #Number of Columns
			m = self.y_train.size #Number of examples
			factor = (alpha/m)

			self.costH = np.zeros(num_iters)

			for iter in range(1,num_iters):
				cost = self.computeCostMulti(self.X_train, self.y_train, self.coeff__) #Get Error
				htheta = self.X_train.dot(self.coeff__)

				correctionX = np.dot(self.X_train.T, (htheta - self.y_train))
				correctionFactor = correctionX * factor

				self.coeff__ = self.coeff__ - correctionFactor

				self.costH[iter] = cost


		def predict(self, X):
			return np.dot(X, self.coeff__)

		def computeCostMulti(self, X, y, theta):
			X = np.array(X)
			y = np.array(y)
			theta = np.array(theta)
			m = y.size #Number of examples
			J = X.dot(theta)
			J = ((sum((J-y)**2)))/(0.5 * m)
			return J
			
		def train(X, Y, layers_dims, learning_rate=0.0075, num_iterations=3000, print_cost=False): #lr was 0.009
		    """
		    Implements a L-layer neural network: [LINEAR->RELU]*(L-1)->LINEAR->SIGMOID.
		    
		    Arguments:
		    X -- data, numpy array of shape (number of examples, num_px * num_px * 3)
		    Y -- true "label" vector (containing 0 if cat, 1 if non-cat), of shape (1, number of examples)
		    layers_dims -- list containing the input size and each layer size, of length (number of layers + 1).
		    learning_rate -- learning rate of the gradient descent update rule
		    num_iterations -- number of iterations of the optimization loop
		    print_cost -- if True, it prints the cost every 100 steps
		    
		    Returns:
		    parameters -- parameters learnt by the model. They can then be used to predict.
		    """

		    costs = []                         # keep track of cost
		    
		    # Parameters initialization.
		    parameters = initialize_parameters_deep(layers_dims)
		    
		    # Loop (gradient descent)
		    for i in range(0, num_iterations):

		        # Forward propagation: [LINEAR -> RELU]*(L-1) -> LINEAR -> SIGMOID.
		        AL, caches = L_model_forward(X, parameters)
		        
		        # Compute cost.
		        cost = compute_cost(AL, Y)

		        # Backward propagation.
		        grads = L_model_backward(AL, Y, caches)

		        # Update parameters.
		        parameters = update_parameters(parameters, grads, learning_rate)

		        # Print the cost every 100 training example
		        if print_cost and i % 100 == 0:
		        	print ("Cost after iteration %i: %f" % (i, cost))
		        	if print_cost and i % 100 == 0:
		        		costs.append(cost)

		    return parameters

		def initialize_parameters_deep(layer_dims):
		    """
		    Arguments:
		    layer_dims -- python array (list) containing the dimensions of each layer in our network
		    
		    Returns:
		    parameters -- python dictionary containing your parameters "W1", "b1", ..., "WL", "bL":
		                    Wl -- weight matrix of shape (layer_dims[l], layer_dims[l-1])
		                    bl -- bias vector of shape (layer_dims[l], 1)
		                    """

		                    np.random.seed(1)
		                    parameters = {}
		    L = len(layer_dims)            # number of layers in the network

		    for l in range(1, L):
		        parameters['W' + str(l)] = np.random.randn(layer_dims[l], layer_dims[l-1]) / np.sqrt(layer_dims[l-1]) #*0.01
		        parameters['b' + str(l)] = np.zeros((layer_dims[l], 1))
		        
		        assert(parameters['W' + str(l)].shape == (layer_dims[l], layer_dims[l-1]))
		        assert(parameters['b' + str(l)].shape == (layer_dims[l], 1))

		        
		        return parameters

	    def L_model_forward(X, parameters):
		    """
		    Implement forward propagation for the [LINEAR->RELU]*(L-1)->LINEAR->SIGMOID computation
		    
		    Arguments:
		    X -- data, numpy array of shape (input size, number of examples)
		    parameters -- output of initialize_parameters_deep()
		    
		    Returns:
		    AL -- last post-activation value
		    caches -- list of caches containing:
		                every cache of linear_relu_forward() (there are L-1 of them, indexed from 0 to L-2)
		                the cache of linear_sigmoid_forward() (there is one, indexed L-1)
		                """

		                caches = []
		                A = X
		    L = len(parameters) // 2                  # number of layers in the neural network
		    
		    # Implement [LINEAR -> RELU]*(L-1). Add "cache" to the "caches" list.
		    for l in range(1, L):
		    	A_prev = A 
		    	A, cache = linear_activation_forward(A_prev, parameters['W' + str(l)], parameters['b' + str(l)], activation = "relu")
		    	caches.append(cache)

		    # Implement LINEAR -> SIGMOID. Add "cache" to the "caches" list.
		    AL, cache = linear_activation_forward(A, parameters['W' + str(L)], parameters['b' + str(L)], activation = "sigmoid")
		    caches.append(cache)
		    
		    assert(AL.shape == (1,X.shape[1]))

		    return AL, caches

		def compute_cost(AL, Y):
		    """
		    Implement the cost function defined by equation (7).
		    Arguments:
		    AL -- probability vector corresponding to your label predictions, shape (1, number of examples)
		    Y -- true "label" vector (for example: containing 0 if non-cat, 1 if cat), shape (1, number of examples)
		    Returns:
		    cost -- cross-entropy cost
		    """
		    
		    m = Y.shape[1]

		    # Compute loss from aL and y.
		    cost = (1./m) * (-np.dot(Y,np.log(AL).T) - np.dot(1-Y, np.log(1-AL).T))
		    
		    cost = np.squeeze(cost)      # To make sure your cost's shape is what we expect (e.g. this turns [[17]] into 17).
		    assert(cost.shape == ())
		    
		    return cost

		def L_model_backward(AL, Y, caches):
		    """
		    Implement the backward propagation for the [LINEAR->RELU] * (L-1) -> LINEAR -> SIGMOID group
		    
		    Arguments:
		    AL -- probability vector, output of the forward propagation (L_model_forward())
		    Y -- true "label" vector (containing 0 if non-cat, 1 if cat)
		    caches -- list of caches containing:
		                every cache of linear_activation_forward() with "relu" (there are (L-1) or them, indexes from 0 to L-2)
		                the cache of linear_activation_forward() with "sigmoid" (there is one, index L-1)
		    
		    Returns:
		    grads -- A dictionary with the gradients
		             grads["dA" + str(l)] = ... 
		             grads["dW" + str(l)] = ...
		             grads["db" + str(l)] = ... 
		    """
		    grads = {}
		    L = len(caches) # the number of layers
		    m = AL.shape[1]
		    Y = Y.reshape(AL.shape) # after this line, Y is the same shape as AL
		    
		    # Initializing the backpropagation
		    dAL = - (np.divide(Y, AL) - np.divide(1 - Y, 1 - AL))
		    
		    # Lth layer (SIGMOID -> LINEAR) gradients. Inputs: "AL, Y, caches". Outputs: "grads["dAL"], grads["dWL"], grads["dbL"]
		    current_cache = caches[L-1]
		    grads["dA" + str(L)], grads["dW" + str(L)], grads["db" + str(L)] = linear_activation_backward(dAL, current_cache, activation = "sigmoid")
		    
		    for l in reversed(range(L-1)):
		        # lth layer: (RELU -> LINEAR) gradients.
		        current_cache = caches[l]
		        dA_prev_temp, dW_temp, db_temp = linear_activation_backward(grads["dA" + str(l + 2)], current_cache, activation = "relu")
		        grads["dA" + str(l + 1)] = dA_prev_temp
		        grads["dW" + str(l + 1)] = dW_temp
		        grads["db" + str(l + 1)] = db_temp

		    return grads


		def update_parameters(parameters, grads, learning_rate):
		    """
		    Update parameters using gradient descent
		    
		    Arguments:
		    parameters -- python dictionary containing your parameters 
		    grads -- python dictionary containing your gradients, output of L_model_backward
		    
		    Returns:
		    parameters -- python dictionary containing your updated parameters 
		                  parameters["W" + str(l)] = ... 
		                  parameters["b" + str(l)] = ...
		    """
		    
		    L = len(parameters) // 2 # number of layers in the neural network

		    # Update rule for each parameter. Use a for loop.
		    for l in range(L):
		        parameters["W" + str(l+1)] = parameters["W" + str(l+1)] - learning_rate * grads["dW" + str(l+1)]
		        parameters["b" + str(l+1)] = parameters["b" + str(l+1)] - learning_rate * grads["db" + str(l+1)]
		        
		    return parameters

		def predict(X, y, parameters):
		    """
		    This function is used to predict the results of a  L-layer neural network.
		    
		    Arguments:
		    X -- data set of examples you would like to label
		    parameters -- parameters of the trained model
		    
		    Returns:
		    p -- predictions for the given dataset X
		    """
		    
		    m = X.shape[1]
		    n = len(parameters) // 2 # number of layers in the neural network
		    p = np.zeros((1,m))
		    
		    # Forward propagation
		    probas, caches = L_model_forward(X, parameters)

		    
		    # convert probas to 0/1 predictions
		    for i in range(0, probas.shape[1]):
		        if probas[0,i] > 0.5:
		            p[0,i] = 1
		        else:
		            p[0,i] = 0
		    
		    #print results
		    #print ("predictions: " + str(p))
		    #print ("true labels: " + str(y))
		    print("Accuracy: "  + str(np.sum((p == y)/m)))
		        
		    return p

		def linear_activation_backward(dA, cache, activation):
		    """
		    Implement the backward propagation for the LINEAR->ACTIVATION layer.
		    
		    Arguments:
		    dA -- post-activation gradient for current layer l 
		    cache -- tuple of values (linear_cache, activation_cache) we store for computing backward propagation efficiently
		    activation -- the activation to be used in this layer, stored as a text string: "sigmoid" or "relu"
		    
		    Returns:
		    dA_prev -- Gradient of the cost with respect to the activation (of the previous layer l-1), same shape as A_prev
		    dW -- Gradient of the cost with respect to W (current layer l), same shape as W
		    db -- Gradient of the cost with respect to b (current layer l), same shape as b
		    """
		    linear_cache, activation_cache = cache
		    
		    if activation == "relu":
		        dZ = relu_backward(dA, activation_cache)
		        dA_prev, dW, db = linear_backward(dZ, linear_cache)
		        
		    elif activation == "sigmoid":
		        dZ = sigmoid_backward(dA, activation_cache)
		        dA_prev, dW, db = linear_backward(dZ, linear_cache)
		    
		    return dA_prev, dW, db

		def L_model_backward(AL, Y, caches):
		    """
		    Implement the backward propagation for the [LINEAR->RELU] * (L-1) -> LINEAR -> SIGMOID group
		    
		    Arguments:
		    AL -- probability vector, output of the forward propagation (L_model_forward())
		    Y -- true "label" vector (containing 0 if non-cat, 1 if cat)
		    caches -- list of caches containing:
		                every cache of linear_activation_forward() with "relu" (there are (L-1) or them, indexes from 0 to L-2)
		                the cache of linear_activation_forward() with "sigmoid" (there is one, index L-1)
		    
		    Returns:
		    grads -- A dictionary with the gradients
		             grads["dA" + str(l)] = ... 
		             grads["dW" + str(l)] = ...
		             grads["db" + str(l)] = ... 
		    """
		    grads = {}
		    L = len(caches) # the number of layers
		    m = AL.shape[1]
		    Y = Y.reshape(AL.shape) # after this line, Y is the same shape as AL
		    
		    # Initializing the backpropagation
		    dAL = - (np.divide(Y, AL) - np.divide(1 - Y, 1 - AL))
		    
		    # Lth layer (SIGMOID -> LINEAR) gradients. Inputs: "AL, Y, caches". Outputs: "grads["dAL"], grads["dWL"], grads["dbL"]
		    current_cache = caches[L-1]
		    grads["dA" + str(L)], grads["dW" + str(L)], grads["db" + str(L)] = linear_activation_backward(dAL, current_cache, activation = "sigmoid")
		    
		    for l in reversed(range(L-1)):
		        # lth layer: (RELU -> LINEAR) gradients.
		        current_cache = caches[l]
		        dA_prev_temp, dW_temp, db_temp = linear_activation_backward(grads["dA" + str(l + 2)], current_cache, activation = "relu")
		        grads["dA" + str(l + 1)] = dA_prev_temp
		        grads["dW" + str(l + 1)] = dW_temp
		        grads["db" + str(l + 1)] = db_temp

		    return grads

		def sigmoid(Z):
		    """
		    Implements the sigmoid activation in numpy
		    
		    Arguments:
		    Z -- numpy array of any shape
		    
		    Returns:
		    A -- output of sigmoid(z), same shape as Z
		    cache -- returns Z as well, useful during backpropagation
		    """
		    
		    A = 1/(1+np.exp(-Z))
		    cache = Z
		    
		    return A, cache

		def relu(Z):
		    """
		    Implement the RELU function.
		    Arguments:
		    Z -- Output of the linear layer, of any shape
		    Returns:
		    A -- Post-activation parameter, of the same shape as Z
		    cache -- a python dictionary containing "A" ; stored for computing the backward pass efficiently
		    """
		    
		    A = np.maximum(0,Z)
		    
		    assert(A.shape == Z.shape)
		    
		    cache = Z 
		    return A, cache


		def relu_backward(dA, cache):
		    """
		    Implement the backward propagation for a single RELU unit.
		    Arguments:
		    dA -- post-activation gradient, of any shape
		    cache -- 'Z' where we store for computing backward propagation efficiently
		    Returns:
		    dZ -- Gradient of the cost with respect to Z
		    """
		    
		    Z = cache
		    dZ = np.array(dA, copy=True) # just converting dz to a correct object.
		    
		    # When z <= 0, you should set dz to 0 as well. 
		    dZ[Z <= 0] = 0
		    
		    assert (dZ.shape == Z.shape)
		    
		    return dZ

		def sigmoid_backward(dA, cache):
		    """
		    Implement the backward propagation for a single SIGMOID unit.
		    Arguments:
		    dA -- post-activation gradient, of any shape
		    cache -- 'Z' where we store for computing backward propagation efficiently
		    Returns:
		    dZ -- Gradient of the cost with respect to Z
		    """
		    
		    Z = cache
		    
		    s = 1/(1+np.exp(-Z))
		    dZ = dA * s * (1-s)
		    
		    assert (dZ.shape == Z.shape)
		    
		    return dZ